# Coveo OmniboxResultList Component (CoveoOmniboxResultList)

The OmniboxResultList component behaves exactly like the ResultList component (which it extends), except that it renders itself inside the Omnibox component.

This component can provide a kind of search-as-you-type functionality, allowing you to easily render complex Result Templates inside the Omnibox component.

Example:

    <div class="CoveoOmniboxResultList">
      <script class="result-template" type="text/x-underscore">
        <div>
          <a class='CoveoResultLink'></a>
        </div>
      </script>
    </div>

## Index

### Methods

- buildResult
- buildResults
- debugInfo
- disable
- displayMoreResults
- enable
- getAutoSelectedFieldsToInclude
- getBindings
- getDisplayedResults
- getDisplayedResultsElements
- renderResults
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID
- elementsToIgnore

### Accessors

- usageAnalytics

### Component Options

- headerTitle
- omniboxZIndex
- onSelect
- queryOverride

### Constructors

- constructor

## Methods

### buildResult

- buildResult(result: IQueryResult): Promise<HTMLElement>

- Inherited from ResultList.buildResult

  - Defined in ui/ResultList/ResultList.ts :448

  Builds and returns an HTMLElement for the given result.

  #### Parameters

  - ##### result: IQueryResult

    the result to build an HTMLElement from.

  #### Returns Promise<HTMLElement>

### buildResults

- buildResults(results: IQueryResults): Promise<HTMLElement[]>

- Overwrites ResultList.buildResults

  - Defined in ui/OmniboxResultList/OmniboxResultList.ts :182

  Builds and returns an array of `HTMLElement` from the IQueryResults set received as an argument.

  #### Parameters

  - ##### results: IQueryResults

    The IQueryResults set to build an array of `HTMLElement` from.

  #### Returns Promise<HTMLElement[]>

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### displayMoreResults

- displayMoreResults(count: number): Promise<IQueryResults>

- Inherited from ResultList.displayMoreResults

  - Defined in ui/ResultList/ResultList.ts :462

  Executes a query to fetch new results. After the query returns, renders the new results.

  Asserts that there are more results to display by verifying whether the last query has returned as many results as requested.

  Asserts that the `ResultList` is not currently fetching results.

  #### Parameters

  - ##### count: number

    The number of results to fetch and display.

  #### Returns Promise<IQueryResults>

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getAutoSelectedFieldsToInclude

- getAutoSelectedFieldsToInclude(): string[]

- Inherited from ResultList.getAutoSelectedFieldsToInclude

  - Defined in ui/ResultList/ResultList.ts :387

  Get the fields needed to be automatically included in the query for this result list.

  #### Returns string[]

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getDisplayedResults

- getDisplayedResults(): IQueryResult[]

- Inherited from ResultList.getDisplayedResults

  - Defined in ui/ResultList/ResultList.ts :494

  Gets the list of currently displayed result.

  #### Returns IQueryResult[]

### getDisplayedResultsElements

- getDisplayedResultsElements(): HTMLElement[]

- Inherited from ResultList.getDisplayedResultsElements

  - Defined in ui/ResultList/ResultList.ts :502

  Gets the list of currently displayed result HTMLElement.

  #### Returns HTMLElement[]

### renderResults

- renderResults(resultElements: HTMLElement[], append?: boolean): Promise<any>

- Overwrites ResultList.renderResults

  - Defined in ui/OmniboxResultList/OmniboxResultList.ts :210

  Creates a result container and appends each element from the received `HTMLElement` array to it. For each element it appends to the result container, this method triggers a `newResultDisplayed` event. Once all elements have been appended to the result container, the method triggers a `newResultsDisplayed` event.

  #### Parameters

  - ##### resultElements: HTMLElement[]

    The array of `HTMLElement` to render.

  - ##### Default value append: boolean = false

  #### Returns Promise<any>

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

### Static elementsToIgnore

elementsToIgnore: string[]

- Defined in ui/OmniboxResultList/OmniboxResultList.ts :61

Specifies a list a css class that should be ignored when the end user click result in the omnibox

Any element that is specified here should normally be able to handle the standard click event.

Any element that does not match this css class and that is clicked will trigger a redirection by the OmniboxResultList.

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### headerTitle

headerTitle: string

- Defined in ui/OmniboxResultList/OmniboxResultList.ts :106

Specifies the title to use for this section.

Default value is the localized string for `Suggested Results`.

Markup configuration example(s) :

    data-header-title='foo'

### omniboxZIndex

omniboxZIndex: number

- Defined in ui/OmniboxResultList/OmniboxResultList.ts :99

Specifies the z-index at which to render the ResultList inside the Omnibox.

Default value is `51`. Minimum value is `16` (Facet components are at `50` by default)

Minimum

  `16`

Default

  `51`

Markup configuration example(s) :

    data-omnibox-z-index='10'

### onSelect

onSelect: function

- Defined in ui/OmniboxResultList/OmniboxResultList.ts :151

Specifies the function to execute when the user selects a result suggestion.

The default function opens the corresponding result URI in the browser.

It is only possible to specify a value for this option in the init call of your search interface. You cannot set it directly as an HTML attribute.

Example:

    // You can call the init script using "pure" JavaScript:
    Coveo.init(document.querySelector('#search'), {
       OmniboxResultList : {
           //Close the omnibox, change the selected HTMLElement background color and alert the result title.
           onSelect : function(result, resultElement, omniBoxObject) {
               omniBoxObject.close();
               resultElement.css('background-color', 'red');
               alert(result.title);
           }
        }
    })

    // Or you can call the init script using the jQuery extension:
    $("#search").coveo("init", {
       OmniboxResultList : {
           //Close the Omnibox, change the selected HTMLElement background color and alert the result title.
           onSelect : function(result, resultElement, omniBoxObject) {
               omniBoxObject.close();
               resultElement.css('background-color', 'red');
               alert(result.title);
           }
        }
    })

#### Type declaration

- - (result: IQueryResult, resultElement: HTMLElement, omniboxObject: IPopulateOmniboxEventArgs): void

  - #### Parameters

    - ##### result: IQueryResult

    - ##### resultElement: HTMLElement

    - ##### omniboxObject: IPopulateOmniboxEventArgs

    #### Returns void

### queryOverride

queryOverride: string

- Defined in ui/OmniboxResultList/OmniboxResultList.ts :113

Specifies the override to use on the query sent to the OmniboxResultList component.

Default value is `undefined`, which means no default override is specified.

Markup configuration example(s) :

    data-query-override='foo'

## Constructors

### constructor

- new OmniboxResultList(element: HTMLElement, options?: IOmniboxResultListOptions, bindings?: IComponentBindings): OmniboxResultList

- Overwrites ResultList.constructor

  - Defined in ui/OmniboxResultList/OmniboxResultList.ts :158

  Creates a new OmniboxResultList component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IOmniboxResultListOptions

    The options for the OmniboxResultList component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns OmniboxResultList

### Implements

- IComponentBindings